% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function [A] = A(flag,alpha1,alpha3,K,g,R,D,phi,B,mu,nu,kappa,Kf)

if flag==1
    A   = (8/(15*pi*mu))*((1-nu)/(2-nu))*((2-nu)*D+3)*(1/alpha1);
elseif flag==2
    s1  = ((2*(1-nu)*((2+kappa)^2+2))/((2+kappa)^2-2))-1+2*nu;
    s2  = 2*(1-nu)*((2+kappa)^2+2)-(1-2*nu)*((2+kappa)^2-2);
%     s3  = (-2*(1-nu)*((2+kappa)^2+2)+mu*((2+kappa)^2-2))^-1;
%     s4  = (1/K-1/Kf-((1-2*nu)^2/(2*mu*(1+nu))))^-1;
    s3  = (-2*(1-nu)*((2+kappa)^2+2)+mu*((2+kappa)^2-2)*(1/K-1/Kf-((1-2*nu)^2/(2*mu*(1+nu)))))^-1;
%     A   = B + (1/(15*mu))*s1*s2*s3*s4;
    A   = B + (1/(15*mu))*s1*s2*s3;
elseif flag==3
    if alpha3==1
        A   = (5/mu)*(4*mu+3*K)/(8*mu+9*K);
    else
        t1  = 2*(1-.5*(-(1+alpha3^2)*(g/alpha3^2)+R*(2-phi+(1+alpha3^2)*(g/alpha3^2))))^-1;
        t2  = (1-(1/4)*(3*phi+g-R*(g-phi)))^-1;
        t3  = (1-(1/4)*(3*phi+g-R*(g-phi)));
        t4  = (B*phi*(3-4*R)+g-R*(g+phi-4/3));
        t5  = 2*(R*(g+phi)-g+B*(1-phi)*(3-4*R));
        t6  = (1-(1/8)*(9*phi+3*g-R*(5*phi+3*g))+.5*B*phi*(3-4*R));
        t7  = 2*(B*(1-phi)*(3-4*R)-1+(3/2)*phi+.5*g-.5*R*(5*phi+g-4));
        t8  = (.5*B*phi*(3-4*R)+.5*g-.5*R*(g-phi));
        t9  = (1-(1/4)*(3*phi+g-R*(g-phi)))^-1;
        t10 = (R*((3/2)*g+(5/2)*phi)-(3/2)*(g+phi)+B*(3-4*R)-.5*(3*B-1)*(3-4*R)*(g+phi-R*(g-phi+2*phi^2)))^-1;
        
        A   = (1/(5*mu))*(t1+t2+(t3*t4+t5*t6-t7*t8)*t9*t10);
    end
end