% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function [thetaout] = theta(flag,K,mu,nu,alpha1,kappa,g,phi,R)

if flag==1
    if nu==.5
        thetaout = (2*(1-nu))/(pi*alpha1*mu);
    else
        thetaout = (4/(3*pi))*(1/K)*((1-nu^2)/(1-2*nu))*(1/alpha1);
    end
elseif flag==2
    if nu==.5
        thetaout = (4*(1-nu)*((2+kappa)^2+2))/(mu*((2+kappa)^2)-2)+(1-2*nu)/(3*K);
    else
        thetaout = (2/(3*K))*(((2*(1-nu^2))/(1-2*nu))*(((2+kappa)^2+2)/((2+kappa)^2-2))+.5*(1-2*nu));
    end
elseif flag==3
    if g==0 && phi==0
        if nu==.5
            thetaout = (9*(1-nu))/(4*mu*(1+nu));
        else
            thetaout = (3/(2*K))*((1-nu)/(1-2*nu));
        end
    else
        d1 = (1-(3*(g+phi)/2-R*((3/2)*g+(5/2)*phi-4/3)));
        d2 = (1-(1+(3/2)*(g+phi)-R*((3/2)*g+(5/2)*phi))+.5*(3-4*R)*(g+phi-R*(g-phi+2*phi^2)))^-1;
        thetaout = K^-1*d1*d2;
    end
end