% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function checkboxMCallback(hObject,event,rgb,panel,field1,field2,field3)

global filmcheck tubecheck sphecheck c1ifield c1cfield c2ifield c2cfield c3ifield c3cfield;

if strcmp(hObject.getText,'films')
    if hObject.isSelected==0
        panel.setBackground(java.awt.Color(rgb));
        
        tmp2(1)     = getnumfieldvalue(field2.getText,'<html>c<sub>1i</sub>');   
        tmp2(2)     = getnumfieldvalue(field3.getText,'<html>c<sub>1c</sub>');
        
        if tubecheck.isSelected==1 && sphecheck.isSelected==1
            tmp(1,1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(1,2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            tmp(2,1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2,2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            
            if sum(tmp2)~=0 && sum(sum(tmp))<1
                c2cfield.setText(num2str(tmp(1,2)+(1-sum(sum(tmp)))/2));
                c3cfield.setText(num2str(tmp(2,2)+(1-sum(sum(tmp)))/2));
            end
        elseif tubecheck.isSelected==1 && sphecheck.isSelected==0
            tmp(1)  = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(2)  = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            
            if sum(tmp2)~=0 && sum(tmp)<1
                c2cfield.setText(num2str(tmp(2)+(1-sum(tmp))));
            end
        elseif tubecheck.isSelected==0 && sphecheck.isSelected==1
            tmp(1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            
            if sum(tmp2)~=0 && sum(tmp)<1
                c3cfield.setText(num2str(tmp(2)+(1-sum(tmp))));
            end
        end
        
        field2.setText('0');
        field3.setText('0');
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        field3.setEnabled(hObject.isSelected);
    else
        panel.setBackground(java.awt.Color.RED);
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        field3.setEnabled(hObject.isSelected);
        
        if tubecheck.isSelected==1 && sphecheck.isSelected==1
            tmp(1,1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(1,2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            tmp(2,1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2,2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            
            if sum(sum(tmp))~=1
                % field2.setText(num2str((1-sum(sum(tmp)))/2));
                field3.setText(num2str((1-sum(sum(tmp)))));
            end
        elseif tubecheck.isSelected==1 && sphecheck.isSelected==0
            tmp(1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            if sum(tmp)~=1
                % field2.setText(num2str((1-sum(tmp))/2));
                field3.setText(num2str((1-sum(tmp))));
            end
        elseif tubecheck.isSelected==0 && sphecheck.isSelected==1
            tmp(1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            if sum(tmp)~=1
                % field2.setText(num2str((1-sum(tmp))/2));
                field3.setText(num2str((1-sum(tmp))));
            end
        else
            % field2.setText(num2str(.5));
            field3.setText(num2str(1));
        end
    end
end
if strcmp(hObject.getText,'tubes')
    if hObject.isSelected==0
        panel.setBackground(java.awt.Color(rgb));
        
        tmp2(1)     = getnumfieldvalue(field2.getText,'<html>c<sub>1i</sub>');   
        tmp2(2)     = getnumfieldvalue(field3.getText,'<html>c<sub>1c</sub>');
        
        if filmcheck.isSelected==1 && sphecheck.isSelected==1
            tmp(1,1) = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(1,2) = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            tmp(2,1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2,2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            
            if sum(tmp2)~=0 && sum(sum(tmp))<1
                c1cfield.setText(num2str(tmp(1,2)+(1-sum(sum(tmp)))/2));
                c3cfield.setText(num2str(tmp(2,2)+(1-sum(sum(tmp)))/2));
            end
        elseif filmcheck.isSelected==1 && sphecheck.isSelected==0
            tmp(1)  = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(2)  = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            
            if sum(tmp2)~=0 && sum(tmp)<1
                c1cfield.setText(num2str(tmp(2)+(1-sum(tmp))));
            end
        elseif filmcheck.isSelected==0 && sphecheck.isSelected==1
            tmp(1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            
            if sum(tmp2)~=0 && sum(tmp)<1
                c3cfield.setText(num2str(tmp(2)+(1-sum(tmp))));
            end
        end
        
        field2.setText('0');
        field3.setText('0');
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        field3.setEnabled(hObject.isSelected);
    else
        panel.setBackground(java.awt.Color.RED)
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        field3.setEnabled(hObject.isSelected);
        
        if filmcheck.isSelected==1 && sphecheck.isSelected==1
            tmp(1,1) = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(1,2) = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            tmp(2,1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2,2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            
            if sum(sum(tmp))~=1
                % field2.setText(num2str((1-sum(sum(tmp)))/2));
                field3.setText(num2str((1-sum(sum(tmp)))));
            end
        elseif filmcheck.isSelected==1 && sphecheck.isSelected==0
            tmp(1) = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(2) = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            if sum(tmp)~=1
                % field2.setText(num2str((1-sum(tmp))/2));
                field3.setText(num2str((1-sum(tmp))));
            end
        elseif filmcheck.isSelected==0 && sphecheck.isSelected==1
            tmp(1) = getnumfieldvalue(c3ifield.getText,'<html>c<sub>3i</sub>');
            tmp(2) = getnumfieldvalue(c3cfield.getText,'<html>c<sub>3c</sub>');
            if sum(tmp)~=1
                % field2.setText(num2str((1-sum(tmp))/2));
                field3.setText(num2str((1-sum(tmp))));
            end
        else
            % field2.setText(num2str(.5));
            field3.setText(num2str(1)); 
        end
    end
end
if strcmp(hObject.getText,'spheroids')
    if hObject.isSelected==0
        panel.setBackground(java.awt.Color(rgb));
        
        tmp2(1)     = getnumfieldvalue(field2.getText,'<html>c<sub>1i</sub>');   
        tmp2(2)     = getnumfieldvalue(field3.getText,'<html>c<sub>1c</sub>');
        
        if filmcheck.isSelected==1 && tubecheck.isSelected==1
            tmp(1,1) = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(1,2) = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            tmp(2,1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(2,2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            
            if sum(tmp2)~=0 && sum(sum(tmp))<1
                c1cfield.setText(num2str(tmp(1,2)+(1-sum(sum(tmp)))/2));
                c2cfield.setText(num2str(tmp(2,2)+(1-sum(sum(tmp)))/2));
            end
        elseif filmcheck.isSelected==1 && tubecheck.isSelected==0
            tmp(1)  = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(2)  = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            
            if sum(tmp2)~=0 && sum(tmp)<1
                c1cfield.setText(num2str(tmp(2)+(1-sum(tmp))));
            end
        elseif filmcheck.isSelected==0 && tubecheck.isSelected==1
            tmp(1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            
            if sum(tmp2)~=0 && sum(tmp)<1
                c2cfield.setText(num2str(tmp(2)+(1-sum(tmp))));
            end
        end
        
        field2.setText('0');
        field3.setText('0');
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        field3.setEnabled(hObject.isSelected);
    else
        panel.setBackground(java.awt.Color.RED);
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        field3.setEnabled(hObject.isSelected);
        
        if filmcheck.isSelected==1 && tubecheck.isSelected==1
            tmp(1,1) = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(1,2) = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            tmp(2,1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(2,2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            
            if sum(sum(tmp))~=1
                % field2.setText(num2str((1-sum(sum(tmp)))/2));
                field3.setText(num2str((1-sum(sum(tmp)))));
            end
        elseif filmcheck.isSelected==1 && tubecheck.isSelected==0
            tmp(1) = getnumfieldvalue(c1ifield.getText,'<html>c<sub>1i</sub>');
            tmp(2) = getnumfieldvalue(c1cfield.getText,'<html>c<sub>1c</sub>');
            if sum(tmp)~=1
                % field2.setText(num2str((1-sum(tmp))/2));
                field3.setText(num2str((1-sum(tmp))));
            end
        elseif filmcheck.isSelected==0 && tubecheck.isSelected==1
            tmp(1) = getnumfieldvalue(c2ifield.getText,'<html>c<sub>2i</sub>');
            tmp(2) = getnumfieldvalue(c2cfield.getText,'<html>c<sub>2c</sub>');
            if sum(tmp)~=1
                % field2.setText(num2str((1-sum(tmp))/2));
                field3.setText(num2str((1-sum(tmp))));
            end
        else
            % field2.setText(num2str(.5));
            field3.setText(num2str(1));    
        end
    end
end

end