% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function checkboxVCallback(hObject,event,rgb,panel,field1,field2)

global filmcheck2 tubecheck2 sphecheck2 c1field2 c2field2 c3field2;

if strcmp(hObject.getText,'films')
    if hObject.isSelected==0
        panel.setBackground(java.awt.Color(rgb));
        
        tmp2        = getnumfieldvalue(field2.getText,'<html>c<sub>1</sub>');
        
        if tubecheck2.isSelected==1 && sphecheck2.isSelected==1
            tmp(1)  = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            tmp(2)  = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            
            if tmp2~=0 && sum(tmp)<1
                c2field2.setText(num2str(tmp(1)+(1-sum(tmp))/2));
                c3field2.setText(num2str(tmp(2)+(1-sum(tmp))/2));
            end
        elseif tubecheck2.isSelected==1 && sphecheck2.isSelected==0
            tmp     = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            
            if tmp2~=0 && tmp<1
                c2field2.setText(num2str(tmp+(1-tmp)));
            end
        elseif tubecheck2.isSelected==0 && sphecheck2.isSelected==1
            tmp     = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            
            if tmp2~=0 && tmp<1
                c3field2.setText(num2str(tmp+(1-tmp)));
            end
        end
        
        field2.setText('0');
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
    else
        panel.setBackground(java.awt.Color.RED);
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        
        if tubecheck2.isSelected==1 && sphecheck2.isSelected==1
            tmp(1)  = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            tmp(2)  = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            
            if sum(tmp)~=1
                field2.setText(num2str(1-sum(tmp)));
            end
        elseif tubecheck2.isSelected==1 && sphecheck2.isSelected==0
            tmp     = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            if tmp~=1
                field2.setText(num2str(1-tmp));
            end
        elseif tubecheck2.isSelected==0 && sphecheck2.isSelected==1
            tmp     = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            if sum(tmp)~=1
                field2.setText(num2str(1-tmp));
            end
        else
            field2.setText(num2str(1));
        end
    end
end
if strcmp(hObject.getText,'tubes')
    if hObject.isSelected==0
        panel.setBackground(java.awt.Color(rgb));
        
        tmp2        = getnumfieldvalue(field2.getText,'<html>c<sub>1</sub>');
        
        if filmcheck2.isSelected==1 && sphecheck2.isSelected==1
            tmp(1)  = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            tmp(2)  = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            
            if tmp2~=0 && sum(tmp)<1
                c1field2.setText(num2str(tmp(1)+(1-sum(tmp))/2));
                c3field2.setText(num2str(tmp(2)+(1-sum(tmp))/2));
            end
        elseif filmcheck2.isSelected==1 && sphecheck2.isSelected==0
            tmp     = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            
            if tmp2~=0 && tmp<1
                c1field2.setText(num2str(tmp+(1-tmp)));
            end
        elseif filmcheck2.isSelected==0 && sphecheck2.isSelected==1
            tmp     = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            
            if tmp2~=0 && tmp<1
                c3field2.setText(num2str(tmp+(1-tmp)));
            end
        end
        
        field2.setText('0');
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
    else
        panel.setBackground(java.awt.Color.RED);
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        
        if filmcheck2.isSelected==1 && sphecheck2.isSelected==1
            tmp(1)  = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            tmp(2)  = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            
            if sum(tmp)~=1
                field2.setText(num2str(1-sum(tmp)));
            end
        elseif filmcheck2.isSelected==1 && sphecheck2.isSelected==0
            tmp     = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            if tmp~=1
                field2.setText(num2str(1-tmp));
            end
        elseif filmcheck2.isSelected==0 && sphecheck2.isSelected==1
            tmp     = getnumfieldvalue(c3field2.getText,'<html>c<sub>3</sub>');
            if sum(tmp)~=1
                field2.setText(num2str(1-tmp));
            end
        else
            field2.setText(num2str(1));
        end
    end
end
if strcmp(hObject.getText,'spheroids')
    if hObject.isSelected==0
        panel.setBackground(java.awt.Color(rgb));
        
        tmp2        = getnumfieldvalue(field2.getText,'<html>c<sub>3</sub>');
        
        if filmcheck2.isSelected==1 && tubecheck2.isSelected==1
            tmp(1)  = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            tmp(2)  = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            
            if tmp2~=0 && sum(tmp)<1
                c1field2.setText(num2str(tmp(1)+(1-sum(tmp))/2));
                c2field2.setText(num2str(tmp(2)+(1-sum(tmp))/2));
            end
        elseif filmcheck2.isSelected==1 && tubecheck2.isSelected==0
            tmp     = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            
            if tmp2~=0 && tmp<1
                c1field2.setText(num2str(tmp+(1-tmp)));
            end
        elseif filmcheck2.isSelected==0 && tubecheck2.isSelected==1
            tmp     = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            
            if tmp2~=0 && tmp<1
                c2field2.setText(num2str(tmp+(1-tmp)));
            end
        end
        
        field2.setText('0');
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
    else
        panel.setBackground(java.awt.Color.RED);
        
        field1.setEnabled(hObject.isSelected);
        field2.setEnabled(hObject.isSelected);
        
        if filmcheck2.isSelected==1 && tubecheck2.isSelected==1
            tmp(1)  = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            tmp(2)  = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            
            if sum(tmp)~=1
                field2.setText(num2str(1-sum(tmp)));
            end
        elseif filmcheck2.isSelected==1 && tubecheck2.isSelected==0
            tmp     = getnumfieldvalue(c1field2.getText,'<html>c<sub>1</sub>');
            if tmp~=1
                field2.setText(num2str(1-tmp));
            end
        elseif filmcheck2.isSelected==0 && tubecheck2.isSelected==1
            tmp     = getnumfieldvalue(c2field2.getText,'<html>c<sub>2</sub>');
            if sum(tmp)~=1
                field2.setText(num2str(1-tmp));
            end
        else
            field2.setText(num2str(1));
        end
    end
    
end

end