% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function plotCallback(hObject,event,tabbedpane,...
    datatable,modplotKucheck,modplotmuucheck,modplotnuucheck,modplotKrcheck,modplotmurcheck,modplotnurcheck,...
    datatable2,viscplotetabcheck,viscplotetascheck,viscplotetabscheck,viscplotnucheck,viscplotuntilfield,...
    modplotvpucheck,modplotvsucheck,modplotvpvsucheck,modplotvprcheck,modplotvsrcheck,modplotvpvsrcheck)

global mainframe;

if tabbedpane.getSelectedIndex()==0
    
    global Mmodels;
    
    selrows     = datatable.getSelectedRows();
    modcol      = zeros(length(selrows),3);
    
    dontst      = 0;
    
    if isempty(selrows)
        dontst  = 1;
        javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>select a model for plot!</html>',...
                'MODEL PLOT ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
    else
        for i=1:length(selrows)
            initcolor   = java.awt.Color.RED;
            tmpcol      = javax.swing.JColorChooser.showDialog(mainframe,['choose color for model ',num2str(Mmodels(selrows(i)+1).id)],initcolor);
            
            if isempty(tmpcol)
                dontst  = 1;
            else
                modcol(i,1) = tmpcol.getRed();
                modcol(i,2) = tmpcol.getGreen();
                modcol(i,3) = tmpcol.getBlue();
            end
        end
    end
    if dontst==0
        l   = 0;
        if modplotKucheck.isSelected()==1 || modplotKrcheck.isSelected()==1
            figbulk     = figure('Name','bulk-moduli','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                if modplotKucheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', K_u'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).K_u,'-','Color',modcol(i,:)./255);
                end
                if modplotKucheck.isSelected()==0 && modplotKrcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', K_r'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).K_r,'-','Color',modcol(i,:)./255);
                end
                if modplotKucheck.isSelected()==1 && modplotKrcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', K_r'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).K_r,'--','Color',modcol(i,:)./255);
                end
            end
            xlabel('total melt fraction \beta');
            ylabel(['bulk moduli K ','[',Mmodels(selrows(i)+1).unit,']']);
            legend(leg)
        end
        l   = 0;
        if modplotmuucheck.isSelected()==1 || modplotmurcheck.isSelected()==1
            figshear     = figure('Name','shear-moduli','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                if modplotmuucheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', \mu_u'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).mu_u,'-','Color',modcol(i,:)./255);
                end
                if modplotmuucheck.isSelected()==0 && modplotmurcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', \mu_r'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).mu_r,'-','Color',modcol(i,:)./255);
                end
                if modplotmuucheck.isSelected()==1 && modplotmurcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', \mu_r'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).mu_r,'--','Color',modcol(i,:)./255);
                end
            end
            xlabel('total melt fraction \beta');
            ylabel(['shear moduli \mu ','[',Mmodels(selrows(i)+1).unit,']']);
            legend(leg)
        end
        l   = 0;
        if modplotnuucheck.isSelected()==1 || modplotnurcheck.isSelected()==1
            figpoisson     = figure('Name','poisson-ratio','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                if modplotnuucheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', \nu_u'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).nu_u,'-','Color',modcol(i,:)./255);
                end
                if modplotnuucheck.isSelected()==0 && modplotnurcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', \nu_r'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).nu_r,'-','Color',modcol(i,:)./255);
                end
                if modplotnuucheck.isSelected()==1 && modplotnurcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', \nu_r'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).nu_r,'--','Color',modcol(i,:)./255);
                end
            end
            xlabel('total melt fraction \beta');
            ylabel('poisson ratio \nu');
            legend(leg);
        end
        l   = 0;
        if modplotvpucheck.isSelected()==1 || modplotvprcheck.isSelected()==1
            figvp     = figure('Name','p-wave velocities','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                if modplotvpucheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{pu}'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).v_pu,'-','Color',modcol(i,:)./255);
                end
                if modplotvpucheck.isSelected()==0 && modplotvprcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{pr}'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).v_pr,'-','Color',modcol(i,:)./255);
                end
                if modplotvpucheck.isSelected()==1 && modplotvprcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{pr}'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).v_pr,'--','Color',modcol(i,:)./255);
                end
            end
            xlabel('total melt fraction \beta');
            ylabel(['p-wave velocity v_p ','[km/s]']);
            legend(leg)
        end
        l   = 0;
        if modplotvsucheck.isSelected()==1 || modplotvsrcheck.isSelected()==1
            figvs     = figure('Name','s-wave velocities','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                if modplotvsucheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{su}'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).v_su,'-','Color',modcol(i,:)./255);
                end
                if modplotvsucheck.isSelected()==0 && modplotvsrcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{sr}'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).v_sr,'-','Color',modcol(i,:)./255);
                end
                if modplotvsucheck.isSelected()==1 && modplotvsrcheck.isSelected()==1
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{sr}'];
                    plot(Mmodels(selrows(i)+1).beta,Mmodels(selrows(i)+1).v_sr,'--','Color',modcol(i,:)./255);
                end
            end
            xlabel('total melt fraction \beta');
            ylabel(['s-wave velocity v_s ','[km/s]']);
            legend(leg)
        end
        l   = 0;
        if modplotvpvsucheck.isSelected()==1 || modplotvpvsrcheck.isSelected()==1
            figvpvs     = figure('Name','p/s-wave velocities ratio','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                if modplotvpvsucheck.isSelected()==1
                    ind     = find(Mmodels(selrows(i)+1).v_su > Mmodels(selrows(i)+1).v_su(1)*.01);
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{pu}/v_{su}'];
                    plot(Mmodels(selrows(i)+1).beta(ind),Mmodels(selrows(i)+1).ratio_psu(ind),'-','Color',modcol(i,:)./255);
                end
                if modplotvpvsucheck.isSelected()==0 && modplotvpvsrcheck.isSelected()==1
                    ind     = find(Mmodels(selrows(i)+1).v_sr > Mmodels(selrows(i)+1).v_sr(1)*.01);
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{pr}/v_{sr}'];
                    plot(Mmodels(selrows(i)+1).beta(ind),Mmodels(selrows(i)+1).ratio_psr(ind),'-','Color',modcol(i,:)./255);
                end
                if modplotvpvsucheck.isSelected()==1 && modplotvpvsrcheck.isSelected()==1
                    ind     = find(Mmodels(selrows(i)+1).v_sr > Mmodels(selrows(i)+1).v_sr(1)*.01);
                    l = l+1;
                    leg{l} = [Mmodels(selrows(i)+1).name,', v_{pr}/v_{sr}'];
                    plot(Mmodels(selrows(i)+1).beta(ind),Mmodels(selrows(i)+1).ratio_psr(ind),'--','Color',modcol(i,:)./255);
                end
            end
            xlabel('total melt fraction \beta');
            ylabel(['p/s-wave ratio','']);
            legend(leg)
        end
    end
elseif tabbedpane.getSelectedIndex()==1
    
    global Vmodels;
    
    selrows     = datatable2.getSelectedRows();
    modcol      = zeros(length(selrows),3);
    
    dontst      = 0;
    
    
    if isempty(selrows)
        dontst  = 1;
        javax.swing.JOptionPane.showMessageDialog(mainframe,...
            '<html>select a model for plot!</html>',...
            'MODEL PLOT ERROR',...
            javax.swing.JOptionPane.ERROR_MESSAGE);
    else
        for i=1:length(selrows)
            initcolor   = java.awt.Color.RED;
            tmpcol      = javax.swing.JColorChooser.showDialog(mainframe,['choose color for model ',num2str(Vmodels(selrows(i)+1).id)],initcolor);
            if isempty(tmpcol)
                dontst  = 1;
            else
                modcol(i,1) = tmpcol.getRed();
                modcol(i,2) = tmpcol.getGreen();
                modcol(i,3) = tmpcol.getBlue();
            end
        end
    end
    if dontst==0
        if viscplotetabcheck.isSelected()==1
            figetab     = figure('Name','bulk-viscosities','NumberTitle','Off');
            
            for i=1:length(selrows)
                leg{i}  = [Vmodels(selrows(i)+1).name];
                if Vmodels(selrows(i)+1).c1~=0
                    leg{i} = [leg{i},', \alpha_1=',num2str(Vmodels(selrows(i)+1).alpha1),', c_1=',num2str(Vmodels(selrows(i)+1).c1)];
                end
                if Vmodels(selrows(i)+1).c2~=0
                    leg{i} = [leg{i},', \kappa=',num2str(Vmodels(selrows(i)+1).kappa),', c_2=',num2str(Vmodels(selrows(i)+1).c2)];
                end
                if Vmodels(selrows(i)+1).c3~=0
                    leg{i} = [leg{i},', \alpha_3=',num2str(Vmodels(selrows(i)+1).alpha3),', c_3=',num2str(Vmodels(selrows(i)+1).c3)];
                end
                findind = find(Vmodels(selrows(i)+1).eta_b >= Vmodels(selrows(i)+1).eta_b(1)*getnumfieldvalue(viscplotuntilfield.getText,'&zeta'));
                semilogy(Vmodels(selrows(i)+1).beta(findind),Vmodels(selrows(i)+1).eta_b(findind),'-','Color',modcol(i,:)./255);
                hold on;
            end
            xlabel('total melt fraction \beta');
            ylabel(['bulk viscosity \eta_b ','[',Vmodels(selrows(i)+1).unit,']']);
            legend(leg)
        end
        if viscplotetascheck.isSelected()==1
            figetas     = figure('Name','shear-viscosities','NumberTitle','Off');
            
            for i=1:length(selrows)
                leg{i}  = [Vmodels(selrows(i)+1).name];
                if Vmodels(selrows(i)+1).c1~=0
                    leg{i} = [leg{i},', \alpha_1=',num2str(Vmodels(selrows(i)+1).alpha1),', c_1=',num2str(Vmodels(selrows(i)+1).c1)];
                end
                if Vmodels(selrows(i)+1).c2~=0
                    leg{i} = [leg{i},', \kappa=',num2str(Vmodels(selrows(i)+1).kappa),', c_2=',num2str(Vmodels(selrows(i)+1).c2)];
                end
                if Vmodels(selrows(i)+1).c3~=0
                    leg{i} = [leg{i},', \alpha_3=',num2str(Vmodels(selrows(i)+1).alpha3),', c_3=',num2str(Vmodels(selrows(i)+1).c3)];
                end
                findind = find(Vmodels(selrows(i)+1).eta_s >= Vmodels(selrows(i)+1).eta_s(1)*getnumfieldvalue(viscplotuntilfield.getText,'&zeta'));
                semilogy(Vmodels(selrows(i)+1).beta(findind),Vmodels(selrows(i)+1).eta_s(findind),'-','Color',modcol(i,:)./255);
                hold on;
            end
            xlabel('total melt fraction \beta');
            ylabel(['shear viscosity \eta_s ','[',Vmodels(selrows(i)+1).unit,']']);
            legend(leg)
        end
        if viscplotetabscheck.isSelected()==1
            figetabs     = figure('Name','shear- and bulk-viscosities','NumberTitle','Off');
            
            for i=1:length(selrows)
                leg{i}  = [Vmodels(selrows(i)+1).name,', \eta_b'];
                if Vmodels(selrows(i)+1).c1~=0
                    leg{i} = [leg{i},', \alpha_1=',num2str(Vmodels(selrows(i)+1).alpha1),', c_1=',num2str(Vmodels(selrows(i)+1).c1)];
                end
                if Vmodels(selrows(i)+1).c2~=0
                    leg{i} = [leg{i},', \kappa=',num2str(Vmodels(selrows(i)+1).kappa),', c_2=',num2str(Vmodels(selrows(i)+1).c2)];
                end
                if Vmodels(selrows(i)+1).c3~=0
                    leg{i} = [leg{i},', \alpha_3=',num2str(Vmodels(selrows(i)+1).alpha3),', c_3=',num2str(Vmodels(selrows(i)+1).c3)];
                end
                findind1 = find(Vmodels(selrows(i)+1).eta_b >= Vmodels(selrows(i)+1).eta_b(1)*getnumfieldvalue(viscplotuntilfield.getText,'&zeta'));
                semilogy(Vmodels(selrows(i)+1).beta(findind1),Vmodels(selrows(i)+1).eta_b(findind1),'-','Color',modcol(i,:)./255);
                hold on;
            end
            l   = length(selrows)+1;
            for i=1:length(selrows)
                leg{l}  = [Vmodels(selrows(i)+1).name,', \eta_s'];
                if Vmodels(selrows(i)+1).c1~=0
                    leg{l} = [leg{l},', \alpha_1=',num2str(Vmodels(selrows(i)+1).alpha1),', c_1=',num2str(Vmodels(selrows(i)+1).c1)];
                end
                if Vmodels(selrows(i)+1).c2~=0
                    leg{l} = [leg{l},', \kappa=',num2str(Vmodels(selrows(i)+1).kappa),', c_2=',num2str(Vmodels(selrows(i)+1).c2)];
                end
                if Vmodels(selrows(i)+1).c3~=0
                    leg{l} = [leg{l},', \alpha_3=',num2str(Vmodels(selrows(i)+1).alpha3),', c_3=',num2str(Vmodels(selrows(i)+1).c3)];
                end
                findind2 = find(Vmodels(selrows(i)+1).eta_s >= Vmodels(selrows(i)+1).eta_s(1)*getnumfieldvalue(viscplotuntilfield.getText,'&zeta'));
                semilogy(Vmodels(selrows(i)+1).beta(findind2),Vmodels(selrows(i)+1).eta_s(findind2),'--','Color',modcol(i,:)./255);
                hold on;
                l = l+1;
            end
            xlabel('total melt fraction \beta');
            ylabel(['viscosities \eta ','[',Vmodels(selrows(i)+1).unit,']']);
            legend(leg)
        end
        if viscplotnucheck.isSelected()==1
            figpoisson     = figure('Name','poisson-ratio','NumberTitle','Off');
            hold on;
            for i=1:length(selrows)
                leg{i}  = [Vmodels(selrows(i)+1).name];
                if Vmodels(selrows(i)+1).c1~=0
                    leg{i} = [leg{i},', \alpha_1=',num2str(Vmodels(selrows(i)+1).alpha1),', c_1=',num2str(Vmodels(selrows(i)+1).c1)];
                end
                if Vmodels(selrows(i)+1).c2~=0
                    leg{i} = [leg{i},', \kappa=',num2str(Vmodels(selrows(i)+1).kappa),', c_2=',num2str(Vmodels(selrows(i)+1).c2)];
                end
                if Vmodels(selrows(i)+1).c3~=0
                    leg{i} = [leg{i},', \alpha_3=',num2str(Vmodels(selrows(i)+1).alpha3),', c_3=',num2str(Vmodels(selrows(i)+1).c3)];
                end
                plot(Vmodels(selrows(i)+1).beta,Vmodels(selrows(i)+1).nu_r,'-','Color',modcol(i,:)./255);
            end
            xlabel('total melt fraction \beta');
            ylabel('poisson ratio \nu');
            legend(leg);
        end
    end
end
end