% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function saveMATCallback(hObject,event,tabbedpane,datatable,datatable2)

global mainframe;

try
    if tabbedpane.getSelectedIndex()==0
        global Mmodels;
        if ~isempty(datatable.getSelectedRows)
            fc          = javax.swing.JFileChooser(java.io.File(pwd));
            filter      = javax.swing.filechooser.FileNameExtensionFilter('*.mat', 'mat');
            fc.setFileFilter(filter);
            fc.showSaveDialog(mainframe);
            savepath    = convertjavastring(fc.getSelectedFile.getAbsolutePath);
            
            mod_models = struct('id',{},...
                'name',{},...
                'betamin',{},...
                'betamax',{},...
                'beta',{},...
                'K_0',{},...
                'mu_0',{},...
                'K_f',{},...
                'rho_0',{},...
                'drho',{},...
                'alpha1',{},'alpha3',{},...
                'kappa',{},...
                'c1i',{},'c1c',{},'c2i',{},'c2c',{},'c3i',{},'c3c',{},...
                'nmax',{},...
                'K_u',{},...
                'K_bar',{},...
                'K_iso',{},...
                'K_r',{},...
                'mu_u',{},...
                'mu_iso',{},...
                'mu_r',{},...
                'nu_u',{},...
                'nu_iso',{},...
                'nu_bar',{},...
                'nu_r',{},...
                'A_u',{},...
                'A_bar',{},...
                'A_iso',{},...
                'rho',{},...
                'v_pu',{},...
                'v_su',{},...
                'ratio_psu',{},...
                'v_pr',{},...
                'v_sr',{},...
                'ratio_psr',{},...
                'unit',{});
            
            
            selrows     = datatable.getSelectedRows();
            
            for i=1:length(selrows)
                mod_models(i)  = Mmodels(selrows(i)+1);
            end
            save(savepath,'mod_models');
        else
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                ['there is no model to save ...!'],...
                'MODEL SAVE ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
        end
    elseif tabbedpane.getSelectedIndex()==1
        global Vmodels;
        if ~isempty(datatable2.getSelectedRows)
            fc          = javax.swing.JFileChooser(java.io.File(pwd));
            filter      = javax.swing.filechooser.FileNameExtensionFilter('*.mat', 'mat');
            fc.setFileFilter(filter);
            fc.showSaveDialog(mainframe);
            savepath    = convertjavastring(fc.getSelectedFile.getAbsolutePath);
            
            visc_models = struct('id',{},...
                'name',{},...
                'betamin',{},...
                'betamax',{},...
                'beta',{},...
                'eta_s0',{},...
                'alpha1',{},'alpha3',{},...
                'kappa',{},...
                'c1',{},'c2',{},'c3',{},...
                'nmax',{},...
                'eta_b',{},...
                'eta_s',{},...
                'nu_r',{},...
                'A_r',{},...
                'unit',{});
            
            selrows     = datatable2.getSelectedRows();
            
            for i=1:length(selrows)
                visc_models(i)  = Vmodels(selrows(i)+1);
            end
            savepath
            save(savepath,'visc_models');
        else
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                ['there is no model to save ...!'],...
                'MODEL SAVE ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
        end
    end
catch exception
    disp(['aborted saving ... ',getReport(exception)]);
end

end