% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function saveTXTCallback(hObject,event,tabbedpane,datatable,datatable2)

global mainframe;

savename        = '.txt';

try
    if tabbedpane.getSelectedIndex()==0
        global Mmodels;
        
        selrows     = datatable.getSelectedRows();
        if ~isempty(datatable.getSelectedRows)
            for i=1:length(selrows)
                try
                    fc          = javax.swing.JFileChooser(java.io.File(pwd));
                    filter      = javax.swing.filechooser.FileNameExtensionFilter('*.txt', 'txt');
                    fc.setFileFilter(filter);
                    fc.showSaveDialog(mainframe);
                    
                    savepath    = convertjavastring(fc.getSelectedFile.getAbsolutePath);
                    
                    wait        = waitbar(0,['Saving ',Mmodels(selrows(i)+1).name,' ...']);
                    set(wait,'Name','Saving ...');
                    
                    fid         = fopen([savepath,savename], 'w');
                    
                    fprintf(fid,'%16s\n','model parameter:');
                    
                    if length(Mmodels(selrows(i)+1).name)>20
                        fprintf(fid,['%',num2str(length(Mmodels(selrows(i)+1).name)),'s '],'modelname');
                    else
                        fprintf(fid,'%20s ','modelname');
                        fprintf(fid,'%12s ','betamin');
                        fprintf(fid,'%12s ','betamax');
                        fprintf(fid,'%12s ','K_0');
                        fprintf(fid,'%12s ','mu_0');
                        fprintf(fid,'%12s ','K_f');
                        fprintf(fid,'%12s ','alpha1');
                        fprintf(fid,'%12s ','kappa');
                        fprintf(fid,'%12s ','alpha3');
                        fprintf(fid,'%12s ','c1i');
                        fprintf(fid,'%12s ','c1c');
                        fprintf(fid,'%12s ','c2i');
                        fprintf(fid,'%12s ','c2c');
                        fprintf(fid,'%12s ','c3i');
                        fprintf(fid,'%12s ','c3c');
                        fprintf(fid,'%12s ','nmax');
                        fprintf(fid,'%20s\n','unit');
                    end
                    
                    if length(Mmodels(selrows(i)+1).name)>20
                        fprintf(fid,['%',num2str(length(Mmodels(selrows(i)+1).name)),'s '],Mmodels(selrows(i)+1).name);
                    else
                        fprintf(fid,'%20s ',Mmodels(selrows(i)+1).name);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).betamin);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).betamax);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).K_0);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).mu_0);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).K_f);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).alpha1);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).kappa);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).alpha3);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).c1i);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).c1c);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).c2i);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).c2c);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).c3i);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).c3c);
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).nmax);
                        fprintf(fid,'%20s\n',Mmodels(selrows(i)+1).unit);
                    end
                    
                    fprintf(fid,'%5s\n','data:');
                    
                    fprintf(fid,'%12s ','beta');
                    
                    fprintf(fid,'%12s ','K_u');
                    fprintf(fid,'%12s ','K_bar');
                    fprintf(fid,'%12s ','K_iso');
                    fprintf(fid,'%12s ','K_r');
                    
                    fprintf(fid,'%12s ','mu_u');
                    fprintf(fid,'%12s ','mu_iso');
                    fprintf(fid,'%12s ','mu_r');
                    
                    fprintf(fid,'%12s ','nu_u');
                    fprintf(fid,'%12s ','nu_bar');
                    fprintf(fid,'%12s ','nu_iso');
                    fprintf(fid,'%12s ','nu_r');
                    
                    fprintf(fid,'%12s ','A_u');
                    fprintf(fid,'%12s ','A_iso');
                    fprintf(fid,'%12s\n','A_r');
                    
                    for k=1:length(Mmodels(selrows(i)+1).beta)
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).beta(k));
                        
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).K_u(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).K_bar(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).K_iso(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).K_r(k));
                        
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).mu_u(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).mu_iso(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).mu_r(k));
                        
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).nu_u(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).nu_bar(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).nu_iso(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).nu_r(k));
                        
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).A_u(k));
                        fprintf(fid,'%2.5e ',Mmodels(selrows(i)+1).A_bar(k));
                        fprintf(fid,'%2.5e\n',Mmodels(selrows(i)+1).A_iso(k));
                        
                        waitbar(k/length(Mmodels(selrows(i)+1).beta),wait,['Saving ',Mmodels(selrows(i)+1).name,' ...']);
                    end
                    
                    fclose(fid);
                    close(wait);
                catch exception
                    fclose(fid);
                    disp(['aborted saving ... ',getReport(exception)]);
                end
            end
        else
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                ['there is no model to save ...!'],...
                'MODEL SAVE ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
        end
    elseif tabbedpane.getSelectedIndex()==1
        global Vmodels;
        
        selrows     = datatable2.getSelectedRows();
        if ~isempty(datatable2.getSelectedRows)
            for i=1:length(selrows)
                try
                    fc          = javax.swing.JFileChooser(java.io.File(pwd));
                    filter      = javax.swing.filechooser.FileNameExtensionFilter('*.txt', 'txt');
                    fc.setFileFilter(filter);
                    fc.showSaveDialog(mainframe);
                    savepath    = convertjavastring(fc.getSelectedFile.getAbsolutePath);
                    
                    wait        = waitbar(0,['Saving ',Vmodels(selrows(i)+1).name,' ...']);
                    set(wait,'Name','Saving ...');
                    
                    fid         = fopen([savepath,savename], 'w');
                    
                    fprintf(fid,'%16s\n','model parameter:');
                    
                    if length(Vmodels(selrows(i)+1).name)>20
                        fprintf(fid,['%',num2str(length(Vmodels(selrows(i)+1).name)),'s '],'modelname');
                    else
                        fprintf(fid,'%20s ','modelname');
                        fprintf(fid,'%12s ','betamin');
                        fprintf(fid,'%12s ','betamax');
                        fprintf(fid,'%12s ','eta_b0');
                        fprintf(fid,'%12s ','eta_s0');
                        fprintf(fid,'%12s ','eta_f');
                        fprintf(fid,'%12s ','alpha1');
                        fprintf(fid,'%12s ','kappa');
                        fprintf(fid,'%12s ','alpha3');
                        fprintf(fid,'%12s ','c1');
                        fprintf(fid,'%12s ','c2');
                        fprintf(fid,'%12s ','c3');
                        fprintf(fid,'%12s ','nmax');
                        fprintf(fid,'%20s\n','unit');
                    end
                    
                    if length(Vmodels(selrows(i)+1).name)>20
                        fprintf(fid,['%',num2str(length(Vmodels(selrows(i)+1).name)),'s '],Vmodels(selrows(i)+1).name);
                    else
                        fprintf(fid,'%20s ',Vmodels(selrows(i)+1).name);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).betamin);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).betamax);
                        fprintf(fid,'%12s ','Inf');
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).eta_s0);
                        fprintf(fid,'%2.5e ',0);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).alpha1);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).kappa);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).alpha3);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).c1);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).c2);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).c3);
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).nmax);
                        fprintf(fid,'%20s\n',Vmodels(selrows(i)+1).unit);
                    end
                    
                    fprintf(fid,'%5s\n','data:');
                    
                    fprintf(fid,'%12s ','beta');
                    
                    fprintf(fid,'%12s ','eta_b');
                    
                    fprintf(fid,'%12s ','eta_s');
                    
                    fprintf(fid,'%12s ','nu_r');
                    
                    fprintf(fid,'%12s\n','A_r');
                    
                    for k=1:length(Vmodels(selrows(i)+1).beta)
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).beta(k));
                        
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).eta_b(k));
                        
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).eta_s(k));
                        
                        fprintf(fid,'%2.5e ',Vmodels(selrows(i)+1).nu_r(k));
                        
                        fprintf(fid,'%2.5e\n',Vmodels(selrows(i)+1).A_r(k));
                        
                        waitbar(k/length(Vmodels(selrows(i)+1).beta),wait,['Saving ',Vmodels(selrows(i)+1).name,' ...']);
                    end
                    
                    fclose(fid);
                    close(wait);
                catch exception
                    fclose(fid);
                    disp(['aborted saving ... ',getReport(exception)]);
                end
            end
        else
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                ['there is no model to save ...!'],...
                'MODEL SAVE ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
        end
    end
    
catch exception
    disp(['aborted saving ... ',getReport(exception)]);
end
end