% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function startCallback(hObject,event,tabbedpane,namefield,k0field,kffield,mu0field,rho0field,drhofield,phiminfield,phimaxfield,phinumfield,nmaxfield,...
    unitbox,alpha1field,c1ifield,c1cfield,kappafield,c2ifield,c2cfield,alpha3field,c3ifield,c3cfield,datatable,...
    namefield2,etas0field,phiminfield2,phimaxfield2,phinumfield2,nmaxfield2,...
    unitfield2,alpha1field2,c1field2,kappafield2,c2field2,alpha3field2,c3field2,datatable2)

global mainframe;

if tabbedpane.getSelectedIndex()==0
    global filmcheck tubecheck sphecheck;
    
    if filmcheck.isSelected()==1 || ...
       tubecheck.isSelected()==1 || ...
       sphecheck.isSelected()==1
        
        K0                      = getnumfieldvalue(k0field.getText,'K<sub>0</sub>');
        
        if isempty(K0)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>K<sub>0</sub> has to be a number! setting K<sub>0</sub> to 0.66 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            K0                  = .66;
            k0field.setText(num2str(K0));
        end
        
        mu0                     = getnumfieldvalue(mu0field.getText,'&mu<sub>0</sub>');
        
        if isempty(mu0)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&mu<sub>0</sub> has to be a number! setting &mu<sub>0</sub> to 0.4 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            mu0                 = .4;
            mu0field.setText(num2str(mu0));
        end
        
        Kf                      = getnumfieldvalue(kffield.getText,'K<sub>f</sub>');
        
        if isempty(mu0)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>K<sub>f</sub> has to be a number! setting K<sub>f</sub> to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            Kf                  = .2;
            kffield.setText(num2str(Kf));
        end
        
        rho0                    = getnumfieldvalue(rho0field.getText,'&rho<sub>0</sub>');
        
        if isempty(rho0)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&rho<sub>0</sub> has to be a number! setting &rho<sub>0</sub> to 3300 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            rho0                = 3300;
            rho0field.setText(num2str(rho0));
        end
        
        drho                    = getnumfieldvalue(drhofield.getText,'&Delta &rho');
        
        if isempty(drho)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&Delta &rho has to be a number! setting &Delta &rho to 300 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            drho                = 300;
            drhofield.setText(num2str(drho));
        end
        
        phimin                  = getnumfieldvalue(phiminfield.getText,'&phi<sub>min</sub>');
        
        if isempty(phimin)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> has to be a number! setting &phi<sub>min</sub> to 10<sup>-6</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield.setText(num2str(phimin));
        end
        
        if phimin==0
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> = 0 is not allowed! &phi<sub>min</sub> is set to 10<sup>-6</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield.setText(num2str(phimin));
        end
        
        if phimin>=1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> &ge 1 makes no sense! &phi<sub>min</sub> is set to 10<sup>-6</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield.setText(num2str(phimin));
        end
        
        phimax                  = getnumfieldvalue(phimaxfield.getText,'&phi<sub>max</sub>');
        
        if isempty(phimax)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>max</sub> has to be a number! setting &phi<sub>max</sub> to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimax              = .2;
            phimaxfield.setText(num2str(phimax));
        end
        
        if phimax==0
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>max</sub> = 0 is not allowed! &phi<sub>max</sub> is set to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimax              = .2;
            phimaxfield.setText(num2str(phimax));
        end
        
        if phimax>1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>max</sub> &gt 1 makes no sense! &phi<sub>max</sub> is set to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimax              = .2;
            phimaxfield.setText(num2str(phimax));
        end
        
        if phimin>=phimax
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> &ge &phi<sub>max</sub> makes no sense! setting &phi<sub>min</sub> = 10<sup>-6</sup> and &phi<sub>max</sub> = 0.2 (default values)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield.setText(num2str(phimin));
            phimax              = .2;
            phimaxfield.setText(num2str(phimax));
        end
        
        phinum                  = getnumfieldvalue(phinumfield.getText,'number of values for &beta');
        
        if isempty(phinum)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>number of values for &phi has to be a number! setting to 10<sup>3</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phinum              = 10^3;
            phinumfield.setText(num2str(phinum));
        end
        
        alpha1                  = getnumfieldvalue(alpha1field.getText,'&alpha<sub>1</sub>');
        
        if alpha1==0
            tmpalpha1           = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>1</sub> = 0 is not allowed! please select 0 &lt &alpha<sub>1</sub> &lt 0.1!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha1              = getnumfieldvalue(tmpalpha1,'&alpha<sub>1</sub>');
            if isempty(alpha1)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>1</sub> field is empty! setting &alpha<sub>1</sub> = 0.01 (default value)!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha1          = .01;
            end
            alpha1field.setText(alpha1);
        end
        
        if alpha1>1
            tmpalpha1 = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>1</sub> &gt 1 is not allowed! model calculation is not possible! please select 0 &lt &alpha<sub>1</sub> &lt 0.1!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha1   = getnumfieldvalue(tmpalpha1,'&alpha<sub>1</sub>');
            if isempty(alpha1)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>1</sub> is again wrong! setting to default value &alpha<sub>1</sub> = 0.01!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha1          = .01;
            end
            alpha1field.setText(alpha1);
        end
        
        if isempty(alpha1)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&alpha<sub>1</sub> field is empty! setting &alpha<sub>1</sub> = 0.01 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha1              = .01;
            alpha1field.setText(num2str(alpha1));
        end
        
        if alpha1>.1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&alpha<sub>1</sub> &gt 0.1! calculation is possible but physical not reasonable!</html>',...
                'MODEL WARNING',...
                javax.swing.JOptionPane.WARNING_MESSAGE);
        end
        
        kappa                   = getnumfieldvalue(kappafield.getText,'&kappa');
        
        if isempty(kappa)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&kappa field is empty! setting &kappa = 0 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            kappa               = 0;
            kappafield.setText(num2str(kappa));
        end
        
        alpha3                  = getnumfieldvalue(alpha3field.getText,'&alpha<sub>3</sub>');
        
        if alpha3==0
            tmpalpha3           = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>3</sub> = 0 is not allowed! please select 0 &lt &alpha<sub>3</sub> &lt 1!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha3              = getnumfieldvalue(tmpalpha3,'&alpha<sub>3</sub>');
            if isempty(alpha3)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>3</sub> is again wrong! setting to default value &alpha<sub>3</sub> = 1!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha3          = 1;
            end
            alpha3field.setText(num2str(alpha3));
        end
        
        if alpha3>1
            tmpalpha3           = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>3</sub> &gt 1 is not allowed! please select 0 &lt &alpha<sub>3</sub> &lt 1!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha3              = getnumfieldvalue(tmpalpha3,'&alpha<sub>3</sub>');
            if isempty(alpha3)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>3</sub> is again wrong! setting to default value &alpha<sub>3</sub> = 1!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha3          = 1;
            end
            alpha3field.setText(num2str(alpha3));
        end
        
        if isempty(alpha3)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&alpha<sub>3</sub> is again wrong! setting to default value &alpha<sub>3</sub> = 1!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha3              = 1;
            alpha3field.setText(num2str(alpha3));
        end
        
        c                       = zeros(3,2);
        
        c(1,1)                  = getnumfieldvalue(c1ifield.getText,'c<sub>1i</sub>');
        c(1,2)                  = getnumfieldvalue(c1cfield.getText,'c<sub>1c</sub>');
        c(2,1)                  = getnumfieldvalue(c2ifield.getText,'c<sub>2i</sub>');
        c(2,2)                  = getnumfieldvalue(c2cfield.getText,'c<sub>2c</sub>');
        c(3,1)                  = getnumfieldvalue(c3ifield.getText,'c<sub>3i</sub>');
        c(3,2)                  = getnumfieldvalue(c3cfield.getText,'c<sub>3c</sub>');
       
        nmax                    = getnumfieldvalue(nmaxfield.getText,'n<sub>max</sub>');
        
        if isempty(nmax)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>n<sub>max</sub> has to be a number! setting n<sub>max</sub> to 10<sup>3</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            nmax                = 10^3;
            nmaxfield.setText(num2str(nmax));
        end
        
        modelname               = convertjavastring(namefield.getText);
        
        if unitbox.getSelectedIndex==0
            corrf               = 10^9;
            unit                = 'GPa';
        elseif unitbox.getSelectedIndex==1
            corrf               = 10^6;
            unit                = 'MPa';
        elseif unitbox.getSelectedIndex==2
            corrf               = 10^3;
            unit                = 'kPa';
        elseif unitbox.getSelectedIndex==3
            corrf               = 10^2;
            unit                = 'hPa';
        elseif unitbox.getSelectedIndex==4
            corrf               = 10^1;
            unit                = 'dPa';
        elseif unitbox.getSelectedIndex==5
            corrf               = 1;
            unit                = 'Pa';
        elseif unitbox.getSelectedIndex==6
            corrf               = 10^-3;
            unit                = 'mPa';
        elseif unitbox.getSelectedIndex==7
            corrf               = 10^-6;
            unit                = '\mu Pa';
        elseif unitbox.getSelectedIndex==8
            corrf               = 10^-9;
            unit                = 'nPa';
        elseif unitbox.getSelectedIndex==9
            corrf               = 10^5*10^6;
            unit                = 'Mbar';
        elseif unitbox.getSelectedIndex==10
            corrf               = 10^5*10^3;
            unit                = 'kbar';
        elseif unitbox.getSelectedIndex==11
            corrf               = 10^5;
            unit                = 'bar';
        elseif unitbox.getSelectedIndex==12
            corrf               = 10^5*10^-3;
            unit                = 'mbar';
        elseif unitbox.getSelectedIndex==13
            corrf               = 10^5*10^-6;
            unit                = '\mu bar';
        end
        
        if sum(sum(c))~=1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
            ['<html>&sum c<sub>ni</sub> + &sum c<sub>nc</sub> has to be <b>1</b>! now it is <b>',num2str(sum(sum(c))),'</b>. change your settings! could not start model ...</html>'],...
            'MODEL START ERROR',...
            javax.swing.JOptionPane.ERROR_MESSAGE);
        else
            calculateMmodelforgui(namefield,modelname,K0,mu0,Kf,rho0,drho,corrf,phimin,phimax,phinum,alpha1,kappa,alpha3,c,nmax,unit,datatable);
        end
    else
        javax.swing.JOptionPane.showMessageDialog(mainframe,...
            '<html>please select a geometry. could not start model!</html>',...
            'MODEL START ERROR',...
            javax.swing.JOptionPane.ERROR_MESSAGE);
    end
elseif tabbedpane.getSelectedIndex()==1
    
    global filmcheck2 tubecheck2 sphecheck2;
    
    if filmcheck2.isSelected()==1 || tubecheck2.isSelected()==1 || sphecheck2.isSelected()==1
        
        etas0                   = getnumfieldvalue(etas0field.getText,'&eta<sub>s0</sub>');
        
        if isempty(etas0)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&eta<sub>s0</sub> has to be a number! setting &eta<sub>s0</sub> to 10<sup>18</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            etas0               = 10^18;
            etas0field.setText(num2str(etas0));
        end
        
        phimin                  = getnumfieldvalue(phiminfield2.getText,'&phi<sub>min</sub>');
        
        if isempty(phimin)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> has to be a number! setting &phi<sub>min</sub> to 10<sup>-6</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield2.setText(num2str(phimin));
        end
        
        if phimin==0
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> = 0 is not allowed! &phi<sub>min</sub> is set to 10<sup>-6</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield2.setText(num2str(phimin));
        end
        
        if phimin>=1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> &ge 1 makes no sense! &phi<sub>min</sub> is set to 10<sup>-6</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield2.setText(num2str(phimin));
        end
        
        phimax                  = getnumfieldvalue(phimaxfield2.getText,'&phi<sub>max</sub>');
        
        if isempty(phimax)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>max</sub> has to be a number! setting &phi<sub>max</sub> to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimax              = .2;
            phimaxfield2.setText(num2str(phimax));
        end
        
        if phimax==0
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>max</sub> = 0 is not allowed! &phi<sub>max</sub> is set to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimax              = .2;
            phimaxfield2.setText(num2str(phimax));
        end
        
        if phimax>1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>max</sub> &gt 1 makes no sense! &phi<sub>max</sub> is set to 0.2 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimax              = .2;
            phimaxfield2.setText(num2str(phimax));
        end
        
        if phimin>=phimax
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&phi<sub>min</sub> &ge &phi<sub>max</sub> makes no sense! setting &phi<sub>min</sub> = 10<sup>-6</sup> and &phi<sub>max</sub> = 0.2 (default values)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phimin              = 10^-6;
            phiminfield2.setText(num2str(phimin));
            phimax              = .2;
            phimaxfield2.setText(num2str(phimax));
        end
        
        phinum                  = getnumfieldvalue(phinumfield2.getText,'number of values for &beta');
        
        if isempty(phinum)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>number of values for &phi has to be a number! setting to 10<sup>3</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            phinum              = 10^3;
            phinumfield2.setText(num2str(phinum));
        end
        
        alpha1                  = getnumfieldvalue(alpha1field2.getText,'&alpha<sub>1</sub>');
        
        if alpha1==0
            tmpalpha1 = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>1</sub> = 0 is not allowed! model calculation is not possible! please select 0 &lt &alpha<sub>1</sub> &lt 0.1</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha1   = getnumfieldvalue(tmpalpha1,'&alpha<sub>1</sub>');
            if isempty(alpha1)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>1</sub> is again wrong! setting to default value &alpha<sub>1</sub> = 0.01!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha1          = .01;
            end
            alpha1field2.setText(alpha1);
        end
        
        if alpha1>1
            tmpalpha1 = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>1</sub> &gt 1 is not allowed! model calculation is not possible! please select 0 &lt &alpha<sub>1</sub> &lt 0.1</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha1   = getnumfieldvalue(tmpalpha1,'&alpha<sub>1</sub>');
            if isempty(alpha1)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>1</sub> is again wrong! setting to default value &alpha<sub>1</sub> = 0.01!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha1          = .01;
            end
            alpha1field2.setText(alpha1);
        end
        
        if alpha1>.1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&alpha<sub>1</sub> &gt 0.1! calculation is possible but physical not reasonable!</html>',...
                'MODEL WARNING',...
                javax.swing.JOptionPane.WARNING_MESSAGE);
        end
        
        kappa                   = getnumfieldvalue(kappafield2.getText,'&kappa');
        
        if isempty(kappa)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>&kappa field is empty! setting &kappa = 0 (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            kappa               = 0;
            kappafield2.setText(num2str(kappa));
        end
        
        alpha3                  = getnumfieldvalue(alpha3field2.getText,'&alpha<sub>3</sub>');
        
        if alpha3==0 
            tmpalpha3 = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>3</sub> = 0 is not allowed! model calculation is not possible! please select 0 &lt &alpha<sub>3</sub> &lt 1</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha3   = getnumfieldvalue(tmpalpha3,'&alpha<sub>3</sub>');
            if isempty(alpha3)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>3</sub> is again wrong! setting to default value &alpha<sub>3</sub> = 1!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha3          = 1;
            end
            alpha3field.setText(alpha3);
        end
        
        if alpha3>1
            tmpalpha3           = javax.swing.JOptionPane.showInputDialog(mainframe,...
                '<html>&alpha<sub>3</sub> &gt 1 is not allowed! please select 0 &lt &alpha<sub>3</sub> &lt 1!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            alpha3              = getnumfieldvalue(tmpalpha3,'&alpha<sub>3</sub>');
            if isempty(alpha3)
                javax.swing.JOptionPane.showMessageDialog(mainframe,...
                    '<html>&alpha<sub>3</sub> is again wrong! setting to default value &alpha<sub>3</sub> = 1!</html>',...
                    'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
                alpha3          = 1;
            end
            alpha3field2.setText(num2str(alpha3));
        end
        
        c                       = zeros(3,1);
        
        c(1)                    = getnumfieldvalue(c1field2.getText,'c<sub>1</sub>');
        c(2)                    = getnumfieldvalue(c2field2.getText,'c<sub>2</sub>');
        c(3)                    = getnumfieldvalue(c3field2.getText,'c<sub>3</sub>');
        
        nmax                    = getnumfieldvalue(nmaxfield2.getText,'n<sub>max</sub>');
        
        if isempty(nmax)
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
                '<html>n<sub>max</sub> has to be a number! setting n<sub>max</sub> to 10<sup>3</sup> (default value)!</html>',...
                'MODEL PARAMETER ERROR',...
                javax.swing.JOptionPane.ERROR_MESSAGE);
            nmax                = 10^3;
            nmaxfield2.setText(num2str(nmax));
        end
        
        modelname               = convertjavastring(namefield2.getText);
        unit                    = convertjavastring(unitfield2.getText);
        if sum(c)~=1
            javax.swing.JOptionPane.showMessageDialog(mainframe,...
            ['<html>&sum c<sub>n</sub> has to be <b>1</b>! now it is <b>',num2str(sum(c)),'</b>. change your settings! could not start model ...</html>'],...
            'MODEL START ERROR',...
            javax.swing.JOptionPane.ERROR_MESSAGE);
        else
            calculateVmodelforgui(namefield2,modelname,etas0,phimin,phimax,phinum,alpha1,kappa,alpha3,c,nmax,unit,datatable2);
        end
    else
        javax.swing.JOptionPane.showMessageDialog(mainframe,...
            'please select a geometry! could not start model ...',...
            'MODEL START ERROR',...
            javax.swing.JOptionPane.ERROR_MESSAGE);
    end
    
end
end