% Copyright (c) 2012, Jan Philipp Kruse and Harro Schmeling, Universitt Frankfurt
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without modification, 
% are permitted provided that the following conditions are met:
% 
% Redistributions of source code must retain the above copyright notice, 
% this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, 
% this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
% INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
% IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
% OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
% WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
% EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function [out] = getnumfieldvalue(in,errtxt)

global mainframe;

tmptmp      = convertjavastring(in);

try 
    out         = str2num(tmptmp);
    if isempty(out) || length(out)>1 || ~isnumeric(out)
        javax.swing.JOptionPane.showMessageDialog(mainframe,...
            ['<html>Exception : ',errtxt,' has to a number!</html>'],...
            'MODEL START ERROR',...
            javax.swing.JOptionPane.ERROR_MESSAGE);
    end
catch exception
    javax.swing.JOptionPane.showMessageDialog(mainframe,...
        ['<html>Exception : ',errtxt,' has to a number!</html>',getReport(exception)],...
        'MODEL START ERROR',...
        javax.swing.JOptionPane.ERROR_MESSAGE);
    disp(getReport(exception));
end